/*
    Copyright 2021, Prusa Development a.s.

    This file is part of SLAGUI

    SLAGUI is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef LICENSEDATASOURCE_H
#define LICENSEDATASOURCE_H

#include <QObject>
#include "license/licenserecord.h"
Q_DECLARE_METATYPE(QList<LicenseRecord*>)
class LicenseDataSource : public QObject
{
    Q_OBJECT

public:
    explicit LicenseDataSource(QObject *parent = nullptr);
    /** Path to the license.manifest file generated by yocto. An option COPY_LIC_MANIFEST needs
     * to be set to "1" for this file to be copied to the target. The default location of this file
     * is "/usr/share/common-licenses/license.manifest".
     */
    Q_PROPERTY(QString manifestPath READ manifestPath WRITE setManifestPath NOTIFY manifestPathChanged)

    /** Accessible storage for the license records of individual packages. Multiple packages per
     * recipe are possible, with different licensing.
     */
    Q_PROPERTY(QList<LicenseRecord*> licenses READ licenses WRITE setLicenses NOTIFY licensesChanged)

    QString manifestPath() const;

    QList<LicenseRecord*> licenses() const;

    /// Count the stored license records
    Q_INVOKABLE int count() const;

signals:
    void manifestPathChanged(QString manifestPath);

    /// Emited before the licenses container is reset/reloaded
    void preResetData();

    /// Emited after the licenses container is reset/reloaded
    void postResetData();

    void licensesChanged(QList<LicenseRecord*> licenses);

public slots:
    void setManifestPath(QString manifestPath);

    void setLicenses(QList<LicenseRecord*> licenses);

private:
    /** @brief Reload license records from the file at manifestPath */
    void reloadData();

    /** @brief Delete all records, then clear the container.
     * Items are heap-allocated, only pointers are stored.
     */
    void clearData();

    QString m_manifestPath;
    QList<LicenseRecord*> m_licenses;
};

#endif // LICENSEDATASOURCE_H
